/*******************************************************************************

  Copyright(c) 2003-2004 Aurelien Reynaud.

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 59
  Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  The full GNU General Public License is included in this distribution in the
  file called COPYING.

*******************************************************************************/


#ifndef HAVE_LIBGGIWMH
# define DISABLE_RESIZE
#endif
#define DISABLE_RESIZE /* resizing disabled anyway for now */
/*#define FORCE_RENDER_COPYBOX*/

/* Default font size for freetype rendering */
#define DEFAULT_FONTSIZE 12

/* Default shell when none is specified and $TERM is empty */
#define DEFAULT_SHELL "/bin/sh"

/* Visual bell duration in µs */
#define FLASH_TIME 1000

/* Number of bytes we read in one go from the app's output:
   - must be greater than the largest escape sequence possible (see terminal.h)
   - input is frozen while output is rendered, so user experience
     commands it must not be too big either
   - when rendering of entire strings gets implemented, a small value will
     prevent taking advantage of it
   128 seems a good compromise... */
#define APP_OUTPUT_SIZE 128

/* wchar_t definition */
#ifdef MULTIBYTE
# include <stdlib.h>
#else
# define wchar_t unsigned int
#endif

typedef struct {
	wchar_t	charcode;
	int	mode;
	int	bgcolor;
	int	fgcolor;
} cell_t;
