/*******************************************************************************

  Copyright(c) 2003-2004 Aurelien Reynaud.

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 59
  Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  The full GNU General Public License is included in this distribution in the
  file called COPYING.

*******************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include "ggiterm.h"
#include "debug.h"
#include "lowlevel/lowlevel.h"
#include "history.h"


extern int terminal_width, terminal_height;

void text_write_area (int, int, int, int);



int region_top, region_bottom;


void change_region (int top, int bottom)
{
	debug (DEBUG_FUNCTION, "called with args (top=%d, bottom=%d)", top, bottom);
	region_top = top < 0 ? 0 : top;
	region_bottom = bottom < 0 ? terminal_height : bottom;
	debug (DEBUG_FUNCTION, "Leaving");
}

void scroll_up (int count)
{
	debug (DEBUG_FUNCTION, "called with args (count=%d)", count);
	if (region_bottom == terminal_height && region_top == 0) {
		history_scroll_up (count);
		render_scroll_up (count);
	} else {
		history_scroll_up_region (region_top, region_bottom, count);
		render_scroll_up_region (region_top, region_bottom, count);
	}
	text_write_area (0, region_bottom-count, terminal_width, count);
	/*render_flush_area (0, region_top, terminal_width, region_bottom - region_top);*/
	/*render_flush ();*/
	/* force flush for the expose event to arrive as quickly as
	   possible to avoid flickering */
	/*handle_expose_events ();*/
	debug (DEBUG_FUNCTION, "Leaving");
}

void scroll_down (int count)
{
	debug (DEBUG_FUNCTION, "called with args (count=%d)", count);
	history_scroll_down_region (region_top, region_bottom, count);
	render_scroll_down_region (region_top, region_bottom, count);
	text_write_area (0, region_top, terminal_width, count);
	/*render_flush_area (0, region_top, terminal_width, region_bottom - region_top);*/
	/*render_flush ();*/
	debug (DEBUG_FUNCTION, "Leaving");
}
